import {
  Diagram
} from "./chunk-6M2S5547.js";
import "./chunk-KK6NJIP6.js";
import "./chunk-QPYNOECS.js";
import "./chunk-Q3LIXKWN.js";
import "./chunk-E6Y3T2AX.js";
import "./chunk-J3FUINPE.js";
import {
  UserMatchingModeToLabel
} from "./chunk-VQXODU6X.js";
import "./chunk-PDRTBLD2.js";
import "./chunk-GIWNVNRE.js";
import "./chunk-ZUJP6VSJ.js";
import "./chunk-AVBYIBK6.js";
import "./chunk-GAW6BCOK.js";
import "./chunk-JTFP5LZR.js";
import "./chunk-CELK62XU.js";
import "./chunk-EOOVVTQ5.js";
import "./chunk-DQGOKED5.js";
import "./chunk-TGERULPP.js";
import "./chunk-FYZ5SQCM.js";
import "./chunk-2YHJVKI6.js";
import "./chunk-SLCA52JF.js";
import "./chunk-L5BH3XSQ.js";
import "./chunk-WSHM74FJ.js";
import "./chunk-VDCG7QQ2.js";
import "./chunk-CESOMQC2.js";
import {
  RbacPermissionsAssignedByUsersListModelEnum
} from "./chunk-7TX62INQ.js";
import "./chunk-WFQSRIYP.js";
import "./chunk-3R4LOWRT.js";
import "./chunk-QUYI6Y4R.js";
import "./chunk-PEJ22FCG.js";
import "./chunk-6BJ64FHW.js";
import "./chunk-4J7IEAXE.js";
import "./chunk-EJLGIYMX.js";
import "./chunk-TUAQYXUG.js";
import {
  banner_default
} from "./chunk-WJSRKCWV.js";
import "./chunk-FNV26V2B.js";
import "./chunk-EGRHWZRV.js";
import "./chunk-73F43635.js";
import "./chunk-VA2LX4GF.js";
import {
  description_list_default
} from "./chunk-DJQHOO67.js";
import "./chunk-HDDJODMO.js";
import "./chunk-CZKC4G2L.js";
import "./chunk-4TFHNOEI.js";
import "./chunk-PEAA73KW.js";
import "./chunk-6GSXAZG4.js";
import "./chunk-WR4EQX5A.js";
import "./chunk-LGSPRTTY.js";
import "./chunk-ZBAJXXE5.js";
import "./chunk-33NGW7YP.js";
import "./chunk-CXDIJQBH.js";
import "./chunk-6CHAI4AU.js";
import "./chunk-S25U5ZDS.js";
import "./chunk-JUWNUVCB.js";
import "./chunk-MN6Z7RFY.js";
import "./chunk-GSF6WJR4.js";
import "./chunk-Q5V2453D.js";
import "./chunk-JYYX7VNL.js";
import "./chunk-WXNJLICI.js";
import "./chunk-U4AAGJML.js";
import "./chunk-YHXV4O6N.js";
import "./chunk-R4VR2VO2.js";
import {
  ProviderTypeEnum,
  SourcesApi,
  UserMatchingModeEnum
} from "./chunk-AGNQU7IJ.js";
import "./chunk-NKL7ZSH6.js";
import "./chunk-SJDM66WU.js";
import "./chunk-H4GRIASJ.js";
import "./chunk-7QGD64EZ.js";
import "./chunk-NQIFOXUT.js";
import "./chunk-UGXOJMVE.js";
import "./chunk-2KF6VQHH.js";
import "./chunk-IIQJL5KX.js";
import "./chunk-UX7TDHO2.js";
import {
  form_default
} from "./chunk-5QPWEKO2.js";
import {
  grid_default
} from "./chunk-XCEM2TDB.js";
import {
  list_default
} from "./chunk-KKOVBVSL.js";
import {
  card_default
} from "./chunk-ITYWTYEW.js";
import "./chunk-WIVGM32M.js";
import "./chunk-EEANTJCZ.js";
import "./chunk-6WPDVYXJ.js";
import {
  Table,
  TableColumn,
  form_control_default
} from "./chunk-6X2XXE6B.js";
import "./chunk-K3AR7TXW.js";
import {
  to
} from "./chunk-QRAXMP7K.js";
import "./chunk-4YZTBUUA.js";
import {
  AKElement,
  DEFAULT_CONFIG,
  EVENT_REFRESH,
  button_default,
  content_default,
  n,
  page_default,
  patternfly_base_default,
  r,
  t
} from "./chunk-JOYOY7UY.js";
import {
  ke,
  msg,
  str
} from "./chunk-XFT4DB4U.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/admin/sources/ldap/LDAPSourceConnectivity.ts
var LDAPSourceConnectivity = class extends AKElement {
  static get styles() {
    return [patternfly_base_default, list_default];
  }
  render() {
    if (!this.connectivity) {
      return ke``;
    }
    return ke`<ul class="pf-c-list">
            ${Object.keys(this.connectivity).map((serverKey) => {
      let serverLabel = ke`${serverKey}`;
      if (serverKey === "__all__") {
        serverLabel = ke`<b>${msg("Global status")}</b>`;
      }
      const server = this.connectivity[serverKey];
      const content = ke`${serverLabel}: ${server.status}`;
      let tooltip = ke`${content}`;
      if (server.status === "ok") {
        tooltip = ke`<pf-tooltip position="top">
                        <ul slot="content" class="pf-c-list">
                            <li>${msg("Vendor")}: ${server.vendor}</li>
                            <li>${msg("Version")}: ${server.version}</li>
                        </ul>
                        ${content}
                    </pf-tooltip>`;
      }
      return ke`<li>${tooltip}</li>`;
    })}
        </ul>`;
  }
};
__decorateClass([
  n()
], LDAPSourceConnectivity.prototype, "connectivity", 2);
LDAPSourceConnectivity = __decorateClass([
  t("ak-source-ldap-connectivity")
], LDAPSourceConnectivity);

// src/admin/sources/ldap/LDAPSourceViewPage.ts
var LDAPSourceViewPage = class extends AKElement {
  set sourceSlug(slug) {
    new SourcesApi(DEFAULT_CONFIG).sourcesLdapRetrieve({
      slug
    }).then((source) => {
      this.source = source;
    });
  }
  static get styles() {
    return [patternfly_base_default, page_default, button_default, grid_default, content_default, card_default, description_list_default, list_default];
  }
  constructor() {
    super();
    this.addEventListener(EVENT_REFRESH, () => {
      if (!this.source?.slug) return;
      this.sourceSlug = this.source?.slug;
    });
  }
  load() {
    new SourcesApi(DEFAULT_CONFIG).sourcesLdapSyncStatusRetrieve({
      slug: this.source.slug
    }).then((state) => {
      this.syncState = state;
    });
  }
  render() {
    if (!this.source) {
      return ke``;
    }
    return ke`<ak-tabs>
            <section
                slot="page-overview"
                data-tab-title="${msg("Overview")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
                @activate=${() => {
      this.load();
    }}
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__body">
                            <dl class="pf-c-description-list pf-m-2-col-on-lg">
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Name")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.name}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Server URI")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.serverUri}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Base DN")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            <ul>
                                                <li>${this.source.baseDn}</li>
                                            </ul>
                                        </div>
                                    </dd>
                                </div>
                            </dl>
                        </div>
                        <div class="pf-c-card__footer">
                            <ak-forms-modal>
                                <span slot="submit"> ${msg("Update")} </span>
                                <span slot="header"> ${msg("Update LDAP Source")} </span>
                                <ak-source-ldap-form slot="form" .instancePk=${this.source.slug}>
                                </ak-source-ldap-form>
                                <button slot="trigger" class="pf-c-button pf-m-primary">
                                    ${msg("Edit")}
                                </button>
                            </ak-forms-modal>
                        </div>
                    </div>
                    <div class="pf-c-card pf-l-grid__item pf-m-2-col">
                        <div class="pf-c-card__title">
                            <p>${msg("Connectivity")}</p>
                        </div>
                        <div class="pf-c-card__body">
                            <ak-source-ldap-connectivity
                                .connectivity=${this.source.connectivity}
                            ></ak-source-ldap-connectivity>
                        </div>
                    </div>
                    <div class="pf-l-grid__item pf-m-10-col">
                        <ak-sync-status-card
                            .fetch=${() => {
      return new SourcesApi(DEFAULT_CONFIG).sourcesLdapSyncStatusRetrieve(
        {
          slug: this.source?.slug
        }
      );
    }}
                            .triggerSync=${() => {
      return new SourcesApi(DEFAULT_CONFIG).sourcesLdapPartialUpdate({
        slug: this.source?.slug || "",
        patchedLDAPSourceRequest: {}
      });
    }}
                        ></ak-sync-status-card>
                    </div>
                </div>
            </section>
            <section
                slot="page-changelog"
                data-tab-title="${msg("Changelog")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__body">
                            <ak-object-changelog
                                targetModelPk=${this.source.pk || ""}
                                targetModelApp="authentik_sources_ldap"
                                targetModelName="ldapsource"
                            >
                            </ak-object-changelog>
                        </div>
                    </div>
                </div>
            </section>
            <ak-rbac-object-permission-page
                slot="page-permissions"
                data-tab-title="${msg("Permissions")}"
                model=${RbacPermissionsAssignedByUsersListModelEnum.SourcesLdapLdapsource}
                objectPk=${this.source.pk}
            ></ak-rbac-object-permission-page>
        </ak-tabs>`;
  }
};
__decorateClass([
  n({ type: String })
], LDAPSourceViewPage.prototype, "sourceSlug", 1);
__decorateClass([
  n({ attribute: false })
], LDAPSourceViewPage.prototype, "source", 2);
__decorateClass([
  r()
], LDAPSourceViewPage.prototype, "syncState", 2);
LDAPSourceViewPage = __decorateClass([
  t("ak-source-ldap-view")
], LDAPSourceViewPage);

// src/admin/sources/oauth/OAuthSourceDiagram.ts
var OAuthSourceDiagram = class extends Diagram {
  constructor() {
    super(...arguments);
    this.refreshHandler = () => {
      if (!this.source) return;
      const graph = ["graph LR"];
      graph.push(`source[${msg(str`OAuth Source ${this.source.name}`)}]`);
      graph.push(
        `source --> flow_manager["${UserMatchingModeToLabel(
          this.source.userMatchingMode || UserMatchingModeEnum.Identifier
        )}"]`
      );
      if (this.source.enrollmentFlow) {
        graph.push("flow_manager --> flow_enroll[Enrollment flow]");
      }
      if (this.source.authenticationFlow) {
        graph.push("flow_manager --> flow_auth[Authentication flow]");
      }
      this.diagram = graph.join("\n");
    };
  }
};
__decorateClass([
  n({ attribute: false })
], OAuthSourceDiagram.prototype, "source", 2);
OAuthSourceDiagram = __decorateClass([
  t("ak-source-oauth-diagram")
], OAuthSourceDiagram);

// src/admin/sources/oauth/OAuthSourceViewPage.ts
function ProviderToLabel(provider) {
  switch (provider) {
    case void 0:
      return "";
    case ProviderTypeEnum.Apple:
      return "Apple";
    case ProviderTypeEnum.Azuread:
      return "Azure Active Directory";
    case ProviderTypeEnum.Discord:
      return "Discord";
    case ProviderTypeEnum.Facebook:
      return "Facebook";
    case ProviderTypeEnum.Github:
      return "GitHub";
    case ProviderTypeEnum.Gitlab:
      return "GitLab";
    case ProviderTypeEnum.Google:
      return "Google";
    case ProviderTypeEnum.Mailcow:
      return "Mailcow";
    case ProviderTypeEnum.Openidconnect:
      return msg("Generic OpenID Connect");
    case ProviderTypeEnum.Okta:
      return "Okta";
    case ProviderTypeEnum.Patreon:
      return "Patreon";
    case ProviderTypeEnum.Reddit:
      return "Reddit";
    case ProviderTypeEnum.Twitter:
      return "Twitter";
    case ProviderTypeEnum.Twitch:
      return "Twitch";
    case ProviderTypeEnum.UnknownDefaultOpenApi:
      return msg("Unknown provider type");
  }
}
var OAuthSourceViewPage = class extends AKElement {
  set sourceSlug(value) {
    new SourcesApi(DEFAULT_CONFIG).sourcesOauthRetrieve({
      slug: value
    }).then((source) => {
      this.source = source;
    });
  }
  static get styles() {
    return [patternfly_base_default, page_default, button_default, grid_default, content_default, card_default, description_list_default];
  }
  constructor() {
    super();
    this.addEventListener(EVENT_REFRESH, () => {
      if (!this.source?.pk) return;
      this.sourceSlug = this.source?.slug;
    });
  }
  render() {
    if (!this.source) {
      return ke``;
    }
    return ke`<ak-tabs>
            <section
                slot="page-overview"
                data-tab-title="${msg("Overview")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__title">${msg("Details")}</div>
                        <div class="pf-c-card__body">
                            <dl class="pf-c-description-list pf-m-2-col-on-lg">
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Name")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.name}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Provider Type")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${ProviderToLabel(this.source.providerType)}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Callback URL")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <code class="pf-c-description-list__text"
                                            >${this.source.callbackUrl}</code
                                        >
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Access Key")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.consumerKey}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Authorization URL")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.type?.authorizationUrl || this.source.authorizationUrl}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Token URL")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.type?.accessTokenUrl || this.source.accessTokenUrl}
                                        </div>
                                    </dd>
                                </div>
                            </dl>
                        </div>
                        <div class="pf-c-card__footer">
                            <ak-forms-modal>
                                <span slot="submit"> ${msg("Update")} </span>
                                <span slot="header"> ${msg("Update OAuth Source")} </span>
                                <ak-source-oauth-form slot="form" .instancePk=${this.source.slug}>
                                </ak-source-oauth-form>
                                <button slot="trigger" class="pf-c-button pf-m-primary">
                                    ${msg("Edit")}
                                </button>
                            </ak-forms-modal>
                        </div>
                    </div>
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__title">${msg("Diagram")}</div>
                        <div class="pf-c-card__body">
                            <ak-source-oauth-diagram
                                .source=${this.source}
                            ></ak-source-oauth-diagram>
                        </div>
                    </div>
                </div>
            </section>
            <section
                slot="page-changelog"
                data-tab-title="${msg("Changelog")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__body">
                            <ak-object-changelog
                                targetModelPk=${this.source.pk || ""}
                                targetModelApp="authentik_sources_oauth"
                                targetModelName="oauthsource"
                            >
                            </ak-object-changelog>
                        </div>
                    </div>
                </div>
            </section>
            <div
                slot="page-policy-binding"
                data-tab-title="${msg("Policy Bindings")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__title">
                            ${msg(
      `These bindings control which users can access this source.
            You can only use policies here as access is checked before the user is authenticated.`
    )}
                        </div>
                        <div class="pf-c-card__body">
                            <ak-bound-policies-list .target=${this.source.pk} ?policyOnly=${true}>
                            </ak-bound-policies-list>
                        </div>
                    </div>
                </div>
            </div>
            <ak-rbac-object-permission-page
                slot="page-permissions"
                data-tab-title="${msg("Permissions")}"
                model=${RbacPermissionsAssignedByUsersListModelEnum.SourcesOauthOauthsource}
                objectPk=${this.source.pk}
            ></ak-rbac-object-permission-page>
        </ak-tabs>`;
  }
};
__decorateClass([
  n({ type: String })
], OAuthSourceViewPage.prototype, "sourceSlug", 1);
__decorateClass([
  n({ attribute: false })
], OAuthSourceViewPage.prototype, "source", 2);
OAuthSourceViewPage = __decorateClass([
  t("ak-source-oauth-view")
], OAuthSourceViewPage);

// src/admin/sources/plex/PlexSourceViewPage.ts
var PlexSourceViewPage = class extends AKElement {
  set sourceSlug(value) {
    new SourcesApi(DEFAULT_CONFIG).sourcesPlexRetrieve({
      slug: value
    }).then((source) => {
      this.source = source;
    });
  }
  static get styles() {
    return [patternfly_base_default, page_default, button_default, grid_default, content_default, card_default, description_list_default];
  }
  constructor() {
    super();
    this.addEventListener(EVENT_REFRESH, () => {
      if (!this.source?.pk) return;
      this.sourceSlug = this.source?.slug;
    });
  }
  render() {
    if (!this.source) {
      return ke``;
    }
    return ke`<ak-tabs>
            <section
                slot="page-overview"
                data-tab-title="${msg("Overview")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__body">
                            <dl class="pf-c-description-list pf-m-2-col-on-lg">
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Name")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.name}
                                        </div>
                                    </dd>
                                </div>
                            </dl>
                        </div>
                        <div class="pf-c-card__footer">
                            <ak-forms-modal>
                                <span slot="submit"> ${msg("Update")} </span>
                                <span slot="header"> ${msg("Update Plex Source")} </span>
                                <ak-source-plex-form slot="form" .instancePk=${this.source.slug}>
                                </ak-source-plex-form>
                                <button slot="trigger" class="pf-c-button pf-m-primary">
                                    ${msg("Edit")}
                                </button>
                            </ak-forms-modal>
                        </div>
                    </div>
                </div>
            </section>
            <section
                slot="page-changelog"
                data-tab-title="${msg("Changelog")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__body">
                            <ak-object-changelog
                                targetModelPk=${this.source.pk || ""}
                                targetModelApp="authentik_sources_plex"
                                targetModelName="plexsource"
                            >
                            </ak-object-changelog>
                        </div>
                    </div>
                </div>
            </section>
            <div
                slot="page-policy-binding"
                data-tab-title="${msg("Policy Bindings")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__title">
                            ${msg(
      `These bindings control which users can access this source.
            You can only use policies here as access is checked before the user is authenticated.`
    )}
                        </div>
                        <div class="pf-c-card__body">
                            <ak-bound-policies-list .target=${this.source.pk} ?policyOnly=${true}>
                            </ak-bound-policies-list>
                        </div>
                    </div>
                </div>
            </div>
            <ak-rbac-object-permission-page
                slot="page-permissions"
                data-tab-title="${msg("Permissions")}"
                model=${RbacPermissionsAssignedByUsersListModelEnum.SourcesPlexPlexsource}
                objectPk=${this.source.pk}
            ></ak-rbac-object-permission-page>
        </ak-tabs>`;
  }
};
__decorateClass([
  n({ type: String })
], PlexSourceViewPage.prototype, "sourceSlug", 1);
__decorateClass([
  n({ attribute: false })
], PlexSourceViewPage.prototype, "source", 2);
PlexSourceViewPage = __decorateClass([
  t("ak-source-plex-view")
], PlexSourceViewPage);

// src/admin/sources/saml/SAMLSourceViewPage.ts
var SAMLSourceViewPage = class extends AKElement {
  set sourceSlug(slug) {
    new SourcesApi(DEFAULT_CONFIG).sourcesSamlRetrieve({
      slug
    }).then((source) => {
      this.source = source;
    });
  }
  static get styles() {
    return [patternfly_base_default, page_default, grid_default, button_default, content_default, card_default, description_list_default];
  }
  constructor() {
    super();
    this.addEventListener(EVENT_REFRESH, () => {
      if (!this.source?.pk) return;
      this.sourceSlug = this.source?.slug;
    });
  }
  render() {
    if (!this.source) {
      return ke``;
    }
    return ke`<ak-tabs>
            <section
                slot="page-overview"
                data-tab-title="${msg("Overview")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__body">
                            <dl class="pf-c-description-list pf-m-3-col-on-lg">
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Name")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.name}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("SSO URL")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.ssoUrl}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("SLO URL")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.sloUrl}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Issuer")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.issuer}
                                        </div>
                                    </dd>
                                </div>
                            </dl>
                        </div>
                        <div class="pf-c-card__footer">
                            <ak-forms-modal>
                                <span slot="submit"> ${msg("Update")} </span>
                                <span slot="header"> ${msg("Update SAML Source")} </span>
                                <ak-source-saml-form slot="form" .instancePk=${this.source.slug}>
                                </ak-source-saml-form>
                                <button slot="trigger" class="pf-c-button pf-m-primary">
                                    ${msg("Edit")}
                                </button>
                            </ak-forms-modal>
                        </div>
                    </div>
                </div>
            </section>
            <section
                slot="page-changelog"
                data-tab-title="${msg("Changelog")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__body">
                            <ak-object-changelog
                                targetModelPk=${this.source.pk || ""}
                                targetModelApp="authentik_sources_saml"
                                targetModelName="samlsource"
                            >
                            </ak-object-changelog>
                        </div>
                    </div>
                </div>
            </section>
            <section
                slot="page-metadata"
                data-tab-title="${msg("Metadata")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
                @activate=${() => {
      new SourcesApi(DEFAULT_CONFIG).sourcesSamlMetadataRetrieve({
        slug: this.source?.slug || ""
      }).then((metadata) => {
        this.metadata = metadata;
      });
    }}
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__body">
                            <ak-codemirror
                                mode=${"xml" /* XML */}
                                ?readOnly=${true}
                                value="${to(this.metadata?.metadata)}"
                            ></ak-codemirror>
                        </div>
                        <div class="pf-c-card__footer">
                            <a
                                class="pf-c-button pf-m-primary"
                                target="_blank"
                                href=${to(this.metadata?.downloadUrl)}
                            >
                                ${msg("Download")}
                            </a>
                        </div>
                    </div>
                </div>
            </section>
            <div
                slot="page-policy-bindings"
                data-tab-title="${msg("Policy Bindings")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__title">
                            ${msg(
      `These bindings control which users can access this source.
            You can only use policies here as access is checked before the user is authenticated.`
    )}
                        </div>
                        <div class="pf-c-card__body">
                            <ak-bound-policies-list .target=${this.source.pk} ?policyOnly=${true}>
                            </ak-bound-policies-list>
                        </div>
                    </div>
                </div>
            </div>
            <ak-rbac-object-permission-page
                slot="page-permissions"
                data-tab-title="${msg("Permissions")}"
                model=${RbacPermissionsAssignedByUsersListModelEnum.SourcesSamlSamlsource}
                objectPk=${this.source.pk}
            ></ak-rbac-object-permission-page>
        </ak-tabs>`;
  }
};
__decorateClass([
  n({ type: String })
], SAMLSourceViewPage.prototype, "sourceSlug", 1);
__decorateClass([
  n({ attribute: false })
], SAMLSourceViewPage.prototype, "source", 2);
__decorateClass([
  r()
], SAMLSourceViewPage.prototype, "metadata", 2);
SAMLSourceViewPage = __decorateClass([
  t("ak-source-saml-view")
], SAMLSourceViewPage);

// src/admin/sources/scim/SCIMSourceGroups.ts
var SCIMSourceGroupList = class extends Table {
  constructor() {
    super(...arguments);
    this.expandable = true;
  }
  searchEnabled() {
    return true;
  }
  async apiEndpoint() {
    return new SourcesApi(DEFAULT_CONFIG).sourcesScimGroupsList({
      ...await this.defaultEndpointConfig(),
      sourceSlug: this.sourceSlug
    });
  }
  columns() {
    return [new TableColumn(msg("Name")), new TableColumn(msg("ID"))];
  }
  renderExpanded(item) {
    return ke`<td role="cell" colspan="4">
            <div class="pf-c-table__expandable-row-content">
                <pre>${JSON.stringify(item.attributes, null, 4)}</pre>
            </div>
        </td>`;
  }
  row(item) {
    return [
      ke`<a href="#/identity/groups/${item.groupObj.pk}">
                <div>${item.groupObj.name}</div>
            </a>`,
      ke`${item.id}`
    ];
  }
};
__decorateClass([
  n()
], SCIMSourceGroupList.prototype, "sourceSlug", 2);
SCIMSourceGroupList = __decorateClass([
  t("ak-source-scim-groups-list")
], SCIMSourceGroupList);

// src/admin/sources/scim/SCIMSourceUsers.ts
var SCIMSourceUserList = class extends Table {
  constructor() {
    super(...arguments);
    this.expandable = true;
  }
  searchEnabled() {
    return true;
  }
  async apiEndpoint() {
    return new SourcesApi(DEFAULT_CONFIG).sourcesScimUsersList({
      ...await this.defaultEndpointConfig(),
      sourceSlug: this.sourceSlug
    });
  }
  columns() {
    return [new TableColumn(msg("Username")), new TableColumn(msg("ID"))];
  }
  renderExpanded(item) {
    return ke`<td role="cell" colspan="4">
            <div class="pf-c-table__expandable-row-content">
                <pre>${JSON.stringify(item.attributes, null, 4)}</pre>
            </div>
        </td>`;
  }
  row(item) {
    return [
      ke`<a href="#/identity/users/${item.userObj.pk}">
                <div>${item.userObj.username}</div>
                <small>${item.userObj.name}</small>
            </a>`,
      ke`${item.id}`
    ];
  }
};
__decorateClass([
  n()
], SCIMSourceUserList.prototype, "sourceSlug", 2);
SCIMSourceUserList = __decorateClass([
  t("ak-source-scim-users-list")
], SCIMSourceUserList);

// src/admin/sources/scim/SCIMSourceViewPage.ts
var SCIMSourceViewPage = class extends AKElement {
  set sourceSlug(value) {
    new SourcesApi(DEFAULT_CONFIG).sourcesScimRetrieve({
      slug: value
    }).then((source) => {
      this.source = source;
    });
  }
  static get styles() {
    return [
      patternfly_base_default,
      page_default,
      button_default,
      form_default,
      form_control_default,
      grid_default,
      content_default,
      card_default,
      description_list_default,
      banner_default
    ];
  }
  constructor() {
    super();
    this.addEventListener(EVENT_REFRESH, () => {
      if (!this.source?.pk) return;
      this.sourceSlug = this.source?.slug;
    });
  }
  render() {
    if (!this.source) {
      return ke``;
    }
    return ke`<ak-tabs>
            <section slot="page-overview" data-tab-title="${msg("Overview")}">
                <div slot="header" class="pf-c-banner pf-m-info">
                    ${msg("SCIM Source is in preview.")}
                    <a href="mailto:hello+feature/scim-source@goauthentik.io"
                        >${msg("Send us feedback!")}</a
                    >
                </div>
                <div class="pf-c-page__main-section pf-m-no-padding-mobile pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__body">
                            <dl class="pf-c-description-list pf-m-2-col-on-lg">
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Name")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.name}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Slug")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.slug}
                                        </div>
                                    </dd>
                                </div>
                            </dl>
                        </div>
                        <div class="pf-c-card__footer">
                            <ak-forms-modal>
                                <span slot="submit"> ${msg("Update")} </span>
                                <span slot="header"> ${msg("Update SCIM Source")} </span>
                                <ak-source-scim-form slot="form" .instancePk=${this.source.slug}>
                                </ak-source-scim-form>
                                <button slot="trigger" class="pf-c-button pf-m-primary">
                                    ${msg("Edit")}
                                </button>
                            </ak-forms-modal>
                        </div>
                    </div>
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card">
                            <div class="pf-c-card__body">
                                <form class="pf-c-form">
                                    <div class="pf-c-form__group">
                                        <label class="pf-c-form__label">
                                            <span class="pf-c-form__label-text"
                                                >${msg("SCIM Base URL")}</span
                                            >
                                        </label>
                                        <input
                                            class="pf-c-form-control"
                                            readonly
                                            type="text"
                                            value="${this.source.rootUrl}"
                                        />
                                    </div>
                                    <div class="pf-c-form__group">
                                        <label class="pf-c-form__label">
                                            <span class="pf-c-form__label-text"
                                                >${msg("Token")}</span
                                            >
                                        </label>
                                        <div>
                                            <ak-token-copy-button
                                                class="pf-m-primary"
                                                identifier="${this.source?.tokenObj.identifier}"
                                            >
                                                ${msg("Click to copy token")}
                                            </ak-token-copy-button>
                                        </div>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </section>
            <section
                slot="page-changelog"
                data-tab-title="${msg("Changelog")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__body">
                            <ak-object-changelog
                                targetModelPk=${this.source.pk || ""}
                                targetModelApp="authentik_sources_scim"
                                targetModelName="scimsource"
                            >
                            </ak-object-changelog>
                        </div>
                    </div>
                </div>
            </section>
            <section
                slot="page-users"
                data-tab-title="${msg("Provisioned Users")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <ak-source-scim-users-list
                        sourceSlug=${this.source.slug}
                    ></ak-source-scim-users-list>
                </div>
            </section>
            <section
                slot="page-groups"
                data-tab-title="${msg("Provisioned Groups")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <ak-source-scim-groups-list
                        sourceSlug=${this.source.slug}
                    ></ak-source-scim-groups-list>
                </div>
            </section>
            <ak-rbac-object-permission-page
                slot="page-permissions"
                data-tab-title="${msg("Permissions")}"
                model=${RbacPermissionsAssignedByUsersListModelEnum.SourcesScimScimsource}
                objectPk=${this.source.pk}
            ></ak-rbac-object-permission-page>
        </ak-tabs>`;
  }
};
__decorateClass([
  n({ type: String })
], SCIMSourceViewPage.prototype, "sourceSlug", 1);
__decorateClass([
  n({ attribute: false })
], SCIMSourceViewPage.prototype, "source", 2);
SCIMSourceViewPage = __decorateClass([
  t("ak-source-scim-view")
], SCIMSourceViewPage);

// src/admin/sources/SourceViewPage.ts
var SourceViewPage = class extends AKElement {
  set sourceSlug(slug) {
    new SourcesApi(DEFAULT_CONFIG).sourcesAllRetrieve({
      slug
    }).then((source) => {
      this.source = source;
    });
  }
  renderSource() {
    if (!this.source) {
      return ke`<ak-empty-state ?loading=${true} ?fullHeight=${true}></ak-empty-state>`;
    }
    switch (this.source?.component) {
      case "ak-source-ldap-form":
        return ke`<ak-source-ldap-view
                    sourceSlug=${this.source.slug}
                ></ak-source-ldap-view>`;
      case "ak-source-oauth-form":
        return ke`<ak-source-oauth-view
                    sourceSlug=${this.source.slug}
                ></ak-source-oauth-view>`;
      case "ak-source-saml-form":
        return ke`<ak-source-saml-view
                    sourceSlug=${this.source.slug}
                ></ak-source-saml-view>`;
      case "ak-source-plex-form":
        return ke`<ak-source-plex-view
                    sourceSlug=${this.source.slug}
                ></ak-source-plex-view>`;
      case "ak-source-scim-form":
        return ke`<ak-source-scim-view
                    sourceSlug=${this.source.slug}
                ></ak-source-scim-view>`;
      default:
        return ke`<p>Invalid source type ${this.source.component}</p>`;
    }
  }
  render() {
    return ke`<ak-page-header
                icon="pf-icon pf-icon-middleware"
                header=${to(this.source?.name)}
                description=${to(this.source?.verboseName)}
            >
            </ak-page-header>
            ${this.renderSource()}`;
  }
};
__decorateClass([
  n({ type: String })
], SourceViewPage.prototype, "sourceSlug", 1);
__decorateClass([
  n({ attribute: false })
], SourceViewPage.prototype, "source", 2);
SourceViewPage = __decorateClass([
  t("ak-source-view")
], SourceViewPage);
export {
  SourceViewPage
};
//# sourceMappingURL=SourceViewPage-JNK3WXLO.js.map
